import { useState, useEffect } from "react";
//  <button onClick={loadData(people.next)}>Next</button>
let SW = () => {
    let [people, setPeople] = useState(null);
    let [loading, setLoading] = useState(false);
    let [details, setDetails] = useState(null);
    let loadData = (data) => {
        setLoading(true);
        fetch(data)
            .then(res => res.json())
            .then(data => {
                setPeople(data);
                setLoading(false);
            });
    }
    useEffect(() => {
        loadData('https://swapi.dev/api/people/');
    }, []);
    useEffect(() => {
        setDetails(null);
    }, []);
    return <div>
        <h3>Star Wars</h3>
        <p></p>
        {loading ? "Loading..." : people &&
            [
                people.previous ? <button key={"previous"} onClick={() => loadData(people.previous)}>Previous</button> : "",
                people.next ? <button key={"next"} onClick={() => loadData(people.next)}>Next</button> : "",
                <ul key={"people"}>
                    {people.results.map(p => {
                        return <li key={p.url}>
                            {p.name}
                            <button onClick={() => setDetails(p)}>Details</button>
                        </li>
                    })}
                </ul>
            ]
        }
        <h4>Details</h4>
        {details ?
            <ul>
                <li key={"name"}>Name : {details.name}</li>
                <li key={"heigt"}>Height : {details.height}</li>
                <li key={"mass"}>Mass : {details.mass}</li>
                <li key={"hair_color"}>Hair color : {details.hair_color}</li>
                <li key={"skin_color"}>Skin color : {details.skin_color}</li>
                <li key={"eye_color"}>Eye color : {details.eye_color}</li>
                <li key={"birth_year"}>Birth year : {details.birth_year}</li>
                <li key={"gender"}>Gender : {details.gender}</li>
                <li key={"films"}>Films :
                    <ul key={"films-list"}>
                        {details.films.map((f, idx) => {
                            return <li key={"film" + idx}><a href={f}>{f}</a></li>
                        })}
                    </ul>
                </li>
            </ul> : "None selected"}
    </div>
}

export default SW;