import useState from "react";
import useLocalState from "./localState"

let TodoList = () => {
    let [items, setItems] = useLocalState('items', [
        { text: "Item 1", done: true },
        { text: "Item 2", done: false },
    ]);
    let [text, setText] = useState('');
    let addItem = text => {
        if (text != "") setItems(current => [{ text, done: false }, ...current]);
    };
    let removeItem = item => {
        setItems(current => current.filter(x => x !== item));
    };
    let updateItem = (item/*  , changes */) => {
        setItems(current => current.map(x => {
            return x === item ? { ...x, done: !x.done } : x;
            // return x === item ? { ...x, ...changes };
        }));
    }
    let handleChange = e => {
        setText(e.target.value);
    };
    let handleSubmit = e => {
        e.preventDefault();
        addItem(text);
        setText('');
    };
    return <div>
        <h3>TodoList</h3>
        <form onSubmit={handleSubmit}>
            <input type="text" value={text} onChange={handleChange} />
            <button>Add</button>
        </form>
        <ul>
            {items.map((i, idx) => {
                return <li key={idx}>
                    {i.done ? <strike>{i.text}</strike> : i.text}
                    <button onClick={() => removeItem(i)}>Remove</button>
                    <input type="checkbox" checked={i.done} onChange={() => updateItem(i)}></input>
                </li>
            })}
        </ul>
    </div>
}

export default TodoList;
