import { useState, useEffect } from "react";

let useLocalState = (key, initialValue) => {
    // Initialise la liste d'états
    let [state, setStates] = useState(initialValue);
    // L'ordre des useEffect est important
    // useEffect sans comparaison fait forcément la fonction qui est changée au démarrage
    // TodoList est evalué une première fois avant que les effects soient executés
    useEffect(() => {
        let state = localStorage.getItem(key);
        if (state) setStates(JSON.parse(state));
    }, []);
    // Si states change, alors j'exécute la function
    useEffect(() => {
        localStorage.setItem(key, JSON.stringify(state));
    }, [state]);
    return [state, setStates];
}

export default useLocalState;
